﻿using System;
using System.Collections.Generic;
// using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using System.Reflection;

namespace Components
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void RunButton_Click(object sender, EventArgs e)
        {
            displayTree(this);
        }

        private void displayTree (Control obj)
        {
            tree.Nodes.Clear ();
            displayBranch (tree.Nodes, obj);
        }

        private void displayBranch (TreeNodeCollection branch, Control obj)
        {
            TreeNode item = new TreeNode ();
            item.Text = obj.ToString();
            item.Tag = obj;
            branch.Add(item);
            foreach (Control c in obj.Controls)
               displayBranch (item.Nodes, c);
        }

        private void put (string s)
        {
            info.AppendText(s + "\r\n");
        }

        private void Tree_NodeMouseClick(object sender, TreeNodeMouseClickEventArgs e)
        {
            object obj = e.Node.Tag;
            prop.SelectedObject = obj;

            info.Text = "";

            Type t = obj.GetType();
            put("Type " + t.FullName);

            // using System.Reflection;
            PropertyInfo[] p = t.GetProperties();
            foreach (PropertyInfo v in p)
            {
                object value = v.GetValue(obj);
                string text = "";
                if (value != null)
                    text = value.ToString();
                // put("Property " + v.Name + " = " + text);

                foreach (CustomAttributeData a in v.CustomAttributes)
                {
                    put("Attribute " + v.Name + " . " + a.ToString ());
                }
            }


        }
    }
}
